# bindy

Python binding для библиотеки **Bindy**.

## Сборка wheel

1. Укажите корректную версию **bindy** в поле **version** в файлах **setup.py** и **pyproject.toml**.

2. Соберите библиотеки **Bindy** для debian, win32, win64.

3. Собранные библиотеки положите в папки **bindy/debian**, **bindy/win32**, **bindy/win64**.

4. Выполните команды:

   ```bash
   python -m pip install wheel
   python setup.py bdist_wheel --universal
   ```

## Запуск примера

1. Скопируйте из корня репозитория файл **sample_keyfile.sqlite** и положите в папку **binding/python**.

2. Запустите сервер:

   ```bash
   python example.py sample_keyfile.sqlite
   ```

3. Запустите клиента:

   ```bash
   python example.py sample_keyfile.sqlite localhost HelloWorld
   ```

## Выпуск релиза на PyPI

1. Поставьте следующие значения в переменные окружения:

   ```
   TWINE_USERNAME=__token__
   TWINE_PASSWORD=<токен от pypi вместе с префиксом pypi->
   ```

   Либо пропишите в файле **.pypirc**, который должен находиться в Вашей домашней директории, следующие строки:

   ```
   [pypi]
   username = __token__
   password = <токен от pypi вместе с префиксом pypi->
   ```

2. Перейдите в папку **scripts** и запустите **release.bat**/**release.sh** в зависимости от ОС.

#### Распространенные проблемы с использованием скриптов release.bat/release.sh

- Если возникла ошибка **"AttributeError: version_info object has no attribute '_\*version\*_'"**, версия Python на Вашем компьютере устарела и не поддерживает **twine** и **build**, необходимые для работы с PyPI. Поставьте более актуальную версию и добавьте её в путь.
- Если возникла ошибка 403, Вы неправильно ввели токен. Проверьте, что Вы не потеряли префикс, без него авторизация не будет выполнена.
- Если возникла ошибка 400, Вы уже загрузили в репозиторий версию с этим номером. К сожалению, PyPI больше не поддерживает замену файлов. Вы можете использовать нумерацию v.v.v-1, v.v.v-2 и т. д. (не рекомендуется) либо загрузить файл, как патч со следующим номером версии.
